//***********************************************
//*                 Main.C                      *
//***********************************************
//* W-AP002 MPLAB C17 Advance Workshop          *
//* Written by: Richard Yang                    *
//*             Sr. Corporate Applications Engr.*
//*             Microchip Technology Inc.       *
//* Date:       16 January 2003                 *
//* Revision:	1                               *
//***********************************************	
//*           	   
//***************************************************
//*   @@@@@mߤ@PWMp
//* pثe T2 ū׻P EEPROM ҳ]wūI  
//* PWM Duty Cycle XAñN䵲Gܦ VT100
//* QPWMXʭåHDuty Cycle覡t
//*
//***************************************************
//*
#include "main.h"

//*           wqܼƨéb Access Bank          
//*********************************************************** 
#pragma udata access My_RAM_1

near unsigned char Str_Len;
near unsigned char i;
near unsigned char T1_Buffer;
near unsigned int T2_Buffer ;
near int EEPROM_Hi_Setting;
near int EEPROM_Low_Setting;
near long Temp_Diff;
near int Temp_Range;
near int Temp_PWM;
near long Temp_24bit;
near char Disp_Duty;

near union
{
	int	Word ;
	unsigned char Byte[2] ;
}Byte2Word ;

near union 
{
int Word;
unsigned char Byte[2];
}EEPROM;

#pragma udata

/* define following variable in data memory at Access Bank */
//*********************************************************** 
#pragma idata access My_RAM_2

near unsigned char Rec_Data=0;
near unsigned char Timer1_Count=0;
near int Slave_update_Count=0;
near unsigned char SW2_Debance=0;

near union
{
	unsigned char Flag;	
	struct {
			unsigned Key_Flag:1;
    		unsigned Timer1_Flag:1;
    		unsigned SW2_Flag:1;
			unsigned Buzzer_On_Flag:1;
			unsigned Buzzer_Fast_Flag:1;
			unsigned Buzzer_Mid_Flag:1;
			unsigned Buzzer_Slow_Flag:1;
			unsigned Shutdown_Flag:1;
    		};		
} Flagbits=0;
#pragma idata

char ASCII_String[10];

//*           wqLCDܪdréb ROM      
//*********************************************************** 
#pragma romdata RomData
const rom char LCD_ROM_MSG1[ ] =" WAP-002 Exer 5 ";
const rom char LCD_ROM_MSG2[ ] ="T1=    ";
const rom char LCD_ROM_MSG3[ ] ="T2=      ";

const far rom char Degree_C[]=" deg.C   ";					//	VT-100 display Table
#pragma code

//*           wq`Ƹ    
//*********************************************************** 
#define SW3 PORTAbits.RA4
#define SW2 PORTBbits.RB0
#define	Timer_Count	3276		// Set for 100mS @32.768KHz 
								// 100mS= T/(1/32768Hz) , T=3276.8

//***********************************************************
/*														   											*/
/* 						Main 	Program					   								*/
/*														   											*/
//***********************************************************
void main(void)
{
	InitializePORT( );
 	InitializeINTs( );
 	InitializeTMR1( );	
	InitializeTMR2( );
	InitializePWM( );
	InitializeUSART( );
    Initialize_I2C_Master( );
 	InitializeAD( );

	OpenLCD( );
	LCD_Set_Cursor(0,0);
	putrsLCD(LCD_ROM_MSG1);			// Display "WAP-002 Exer5 " on Line 1

	InitializeVT100( );				// Clear Terminal screen & put cursoe on (0,0)	
	VT100_Fill_Screen(0);			// Fill the initialize charactor on VT-100
	VT100_Cursor_Position(8,51);

		while(1)
	{
		Rec_Cmd_Check( );

		if (Flagbits.Timer1_Flag)
		{
			Flagbits.Timer1_Flag=0;


			switch (Timer1_Count)
			{
				case 0x00:
				LCD_Temp_Update( );	
				break;

				case 0x01:
			    VT_100_Update( );
				break;

				case 0x02:
				EEPROM_Update( );
				break;

				case 0x03:
				PWM_Control( );
				break;

//				case 0x04:
//				Temp_Compare( );
//				break;
			}
		}

 	} 
}

//*******************************************************
//*            Calculate The PWM Duty Cycle    			*
//*														*
//*    PWM = 0x3FF * (T2 - T2_Min)/(T2_Max - T2_Min)	*
//*******************************************************


void PWM_Control(void)
{
	if (Flagbits.Shutdown_Flag==1)		// =1, Shutdown
	{
		VT100_Cursor_Position(13,69);	
		Print_Byte('-');
		Print_Byte('-');
		Print_Byte('-');
		Print_Byte('%');
	}
	else								// =0, Normal Operation
	{

		if (T2_Buffer>=EEPROM_Hi_Setting) Temp_PWM= 0x3FF;
		else if (T2_Buffer<=EEPROM_Low_Setting) Temp_PWM= 0x001;
		else
		{

//***************************************************
//*   @@@@@mߤ@PWMp
//* pDuty CycleXAñN䵲GePWM2
//* ΦbVT100ܨʤ
//*
//***************************************************
			Temp_PWM=(1024 * (long)(T2_Buffer-EEPROM_Low_Setting))/
			         (EEPROM_Hi_Setting - EEPROM_Low_Setting);
		}
		SetDCPWM2(Temp_PWM);
	
		Disp_Duty= (100 * (long)( Temp_PWM)) / 0x3FF;

		VT100_Cursor_Position(13,69);			 
	 	btoa(Disp_Duty,ASCII_String);
		VT100_Clear_Right( );
		putsUSART(ASCII_String);
		Print_Byte('%');
	}
}
//***************************************************
//*  The function will get the temperature setting  *
//*  data from EEPROM and convert to BCD ASCII code *
//*  than update to VT100 terminal                  *
//*************************************************** 
void EEPROM_Update(void)
{
	EEPROM.Byte[0]=EE_Read(0x00);		// Read Maximun Temperature Setting fromEEPROM
	EEPROM.Byte[1]=EE_Read(0x01);
	EEPROM_Hi_Setting=EEPROM.Word;

	VT100_Cursor_Position(20,68);
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	VT100_Cursor_Position(20,68);
	Print_Temperature(EEPROM_Hi_Setting);

	EEPROM.Byte[0]=EE_Read(0x02);		// Read Maximun Temperature Setting fromEEPROM
	EEPROM.Byte[1]=EE_Read(0x03);
	EEPROM_Low_Setting=EEPROM.Word;
	VT100_Cursor_Position(21,68);
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	Print_Byte(' ');
	VT100_Cursor_Position(21,68);
	Print_Temperature(EEPROM_Low_Setting);

}
//***********************************
//* Internal EEPROM Access Function	*
//***********************************

void EE_Write (unsigned char EE_Address, unsigned char EE_Data)
{
	PIR2bits.EEIF = 0;
	EEADR = EE_Address;
	EEDATA = EE_Data;
	EECON1bits.EEPGD = 0;
	EECON1bits.WREN = 1;
	INTCONbits.GIE = 0;

	_asm
		MOVLW	0X55
		MOVWF	EECON2,0
		MOVLW	0XAA
		MOVWF	EECON2,0
		BSF		EECON1,1,0
	_endasm

	INTCONbits.GIE = 1;
	while (!PIR2bits.EEIF);
	PIR2bits.EEIF = 0;
	EECON1bits.WREN = 0;
}

unsigned char EE_Read (unsigned char EE_Address)
{
	EEADR = EE_Address;
	EECON1bits.EEPGD = 0;
	EECON1bits.RD = 1;
	return EEDATA;
}

//***************************************************
//*  The function will update the T1 & T2 on VT100  *
//***************************************************

void VT_100_Update(void)
{
	Slave_update_Count ++;						// Update the Slave Update counter
  	itoa(Slave_update_Count,ASCII_String);		
  	VT100_Cursor_Position(11,39);
	VT100_Clear_Right( );
	putsUSART(ASCII_String);

	VT100_Cursor_Position(13,32);				// Update Temperature 1
 	btoa(T1_Buffer,ASCII_String);
  	putsUSART(ASCII_String);
 	putrsUSART(Degree_C);							 
 	WriteUSART(' ');

	T2_Buffer=Read_TC1047_Temperature( );
	VT100_Cursor_Position(15,32);				// Update Temperature 2
	Print_Temperature(T2_Buffer);
		
}

void Print_Temperature(int Data)
{
	if (Data==0) WriteUSART('0');				// T2 = 0 , Display "0" on LCD
	else
	{
 		itoa(Data,ASCII_String);			  	// Convert to ASCII string
		Str_Len = strlen(ASCII_String);			// Get length for the ASCII-String
		
		for (i=0;i<Str_Len;i++)							
		{
			if (i==(Str_Len-1))					// Looking for the point
			{
				if (Str_Len==1) Print_Byte('0');	// Just one digital, add "0"
				Print_Byte('.');			    // Add the point
			}
		
			Print_Byte(ASCII_String[i]);		// Display the ASCII_String on LCD
		}
	}
 	putrsUSART(Degree_C);
}

void Print_Byte(unsigned char Byte)
{
	while (BusyUSART( ));
	WriteUSART(Byte);
}

//***************************************************
//*    The function will update the T1 & T2 on LCD 	*
//***************************************************
//*          Display LCD format on Line 2  			*
//* " T1=20* T2=101.8* " with auto position scaling *
//***************************************************
void LCD_Temp_Update (void)
{
	//*** Display TC74-A7 Temperature on LCD  ***
	LCD_Set_Cursor(1,0);
	putrsLCD(LCD_ROM_MSG2);							// DIsplay "T1=   "

	LCD_Set_Cursor(1,3);					
	Byte2Word.Word = Read_TC74_Temperature( );  	// Get Current Temperature form TC74-A7

	if ( Byte2Word.Byte[1] == 0 )
	{
		T1_Buffer=Byte2Word.Byte[0];				// Copy T1 to buffer for VT100
		btoa(Byte2Word.Byte[0],ASCII_String);		// Convert Temp. Hax to ASCII string
  		putsLCD(ASCII_String);						// Print to LCD
		putcLCD(0xDF);							 	// Add degree symbol
	}
 	else if ( Byte2Word.Byte[1] == -1 )					// Read fail from TC74-A7, Display "--" on LCD
  	{
		putcLCD('-') ;		
		putcLCD('-') ;
	}


	//**** Display TC1047A Temperature on LCD  ***
	LCD_Set_Cursor(1,7);
	putrsLCD(LCD_ROM_MSG3);							// DIsplay "T2=   "

	LCD_Set_Cursor(1,10);					 
	T2_Buffer=Read_TC1047_Temperature( );			// Get Current Temperature from TC1047A
	if (T2_Buffer==0) putcLCD('0');
	else
	{
		itoa(T2_Buffer,ASCII_String);				// Convert to ASCII string
		Str_Len = strlen(ASCII_String);				// Get length for the ASCII-String
	
		for (i=0;i<Str_Len;i++)							
		{
			if (i==(Str_Len-1))						// Looking for the point
			{
				if (Str_Len==1) putcLCD('0'); 		// Just one digital, add "0"
				putcLCD('.');				 		// Add the point
			}
			putcLCD(ASCII_String[i]);				// Display the ASCII_String on LCD

		}
	}		
	putcLCD(0xDF);									// Add degree symbol
}

//************************************************
//* Function: isr_high_direct                    *
//*   - Direct execution to the actual           *
//*     Hi-priority interrupt code.              *
//************************************************
#pragma code isrhighcode = 0x0008

void isr_high_direct(void)	
{  								
     _asm 			//begin in-line assembly
     goto isr_high	//go to isr_high function
     _endasm 		//end in-line assembly
}
#pragma code

//************************************************
//* Function: isr_high(void)                     *     
//*   High priority interrupt:	                 *
//*   - Received a serial data from RS-232       *
//*     Save the received data to buffer Rec_Data*  
//*   - Timer 2 Interrupt : 5 mS 				 *              
//************************************************
#pragma interrupt isr_high 

void isr_high(void)
{
 	if (PIR1bits.RCIF)
	{
		 Rec_Data=ReadUSART();				// Get RS-232 data
	}

	if (PIR1bits.TMR2IF)

	{		
 		PIR1bits.TMR2IF=0;
 		
 		if (SW2_Debance!=0)
 		{	
			if (!SW2 | !SW3) SW2_Debance=10;
			else	SW2_Debance--;
		}	
		else 
		{
			if (!SW3)
			{ 
				Flagbits.Key_Flag =1 ;
		 		SW2_Debance=10;
			}
			if (!SW2)
			{ 	
				Flagbits.SW2_Flag=!Flagbits.SW2_Flag; 
				SW2_Debance=10;
			}
		}		
	}
}					

//************************************************
//* Function: isr_low(void)                      *     
//*  - Timer 1 Interrupt for the 100mS Time Base *
//*    for send the ON BUS polling				 *          
//************************************************
#pragma interruptlow isr_low 

void isr_low(void)
{

		WriteTimer1(65536-Timer_Count);		  		// Reload 0.1 Second value to Timer1
		PIR1bits.TMR1IF=0;							// Clear interrupt flag of Timer 1

		Flagbits.Timer1_Flag=1;						// Set for program task 
		if (Timer1_Count==5) Timer1_Count =0;
		else	Timer1_Count ++;

}								
#pragma code

//************************************************
//* Function: isr_low_direct                    *
//*   - Direct execution to the actual          *
//*     low-priority interrupt code.            *
//************************************************
#pragma code isrlowcode = 0x0018

void isr_low_direct(void)	
{  								
     _asm 				//begin in-line assembly
     goto isr_low		//go to isr_high function
     _endasm 			//end in-line assembly
}
#pragma code

